\ Open Memory Test Language examples
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\
\ Concepts adapted from:
\
\ Automatic Memory Test Verification and Generation
\ Masters Thesis writen by A. Offerman
\ Section Computer Architecture & Digital Systems
\ Department of Electrical Engineering
\ Delft University of Technology
\ The Netherlands
\ August 1995

require Classes/Test.fth

new_Test Zero-One       ( 4n )      +" x { up (w0); up (r0); up (w1); up (r1)}"

new_Test MATS           ( 4n )      +" { updown (w0); updown (r0,w1); updown (r1)}"
new_Test MATS+          ( 5n )      +" { updown (w0);     up (r0,w1);   down (r1,w0)}"
new_Test MATS++         ( 6n )      +" { updown (w0);     up (r0,w1);   down (r1,w0,r0)}"
new_Test MATS-OR                    +" { updown (w0); updown (r0,w1); updown (r1)}"
new_Test MATS-AND                   +" { updown (w1); updown (r1,w0); updown (r0)}"

new_Test March_C-       ( 10n )     +" { updown (w0); up (r0,w1);   up (r1,w0);"
    algorithm                                    +" down (r0,w1); down (r1,w0); updown (r0)}"

new_Test PMOVI          ( 13n )     +" { updown (w0); up (r0,w1,r1);   up (r1,w0,r0);"
    algorithm                                    +" down (r0,w1,r1); down (r1,w0,r0)}"
new_Test MOVI                       +" {   down (w0); up (r0,w1,r1);   up (r1,w0,r0);"
    algorithm                                    +" down (r0,w1,r1); down (r1,w0,r0)}"

new_Test March_SR       ( 14n )     +" { updown (w0); up (r0,w1,r1,w0);   up (r0,r0); up (w1);"
    algorithm                                    +" down (r1,w0,r0,w1); down (r1,r1)}"

new_Test March_SS       ( 22n )     +" { updown (w0); up (r0,r0,w0,r0,w1);   up (r1,r1,w1,r1,w0);"
    algorithm                                    +" down (r0,r0,w0,r0,w1); down (r1,r1,w1,r1,w0); updown (r0)}"

new_Test March_G        ( 23n )     +" { updown (w0); up (r0,w1,r1,w0,r0,w1); up (r1,w0,w1);"
    algorithm                                    +" down (r1,w0,w1,w0);     down (r0,w1,w0);"
    algorithm                               +" T; updown (r0,w1,r1);   T; updown (r1,w0,r0)}"

new_Test March_RAW      ( 26n )     +" { updown (w0); up (r0,w0,r0,r0,w1,r1);   up (r1,w1,r1,r1,w0,r0);"
    algorithm                                    +" down (r0,w0,r0,r0,w1,r1); down (r1,w1,r1,r1,w0,r0); updown (r0)}"

new_Test Hammer         ( 49n )     +" { up (w0); up (r0,w1,w1,w1,w1,w1,w1,w1,w1,w1,w1,r1);"
	algorithm								   +" up (r1,w0,w0,w0,w0,w0,w0,w0,w0,w0,w0,r0);"
    algorithm                                +" down (r0,w1,w1,w1,w1,w1,w1,w1,w1,w1,w1,r1);"
    algorithm								 +" down (r1,w0,w0,w0,w0,w0,w0,w0,w0,w0,w0,r0)}"

new_Test Marching_1/0               +" { updown (w0);   up (r0, w1, r1); down (r1, w0, r0);"
    algorithm                         +" updown (w1);   up (r1, w0, r0); down (r0, w1, r1)}"
new_Test March_X        ( 6n )      +" { updown (w0);   up (r0, w1);     down (r1, w0); updown (r0)}"
new_Test March_C                    +" { updown (w0);   up (r0, w1);       up (r1, w0);"
    algorithm                         +" updown (r0); down (r0, w1);     down (r1, w0); updown (r0)}"

new_Test March_A        ( 15n )     +" { updown (w0); up (r0, w1, w0, w1);   up (r1, w0, w1);"
    algorithm                                    +" down (r1, w0, w1, w0); down (r0, w1, w0)}"
new_Test March_Y        ( 8n )      +" { updown (w0); up (r0, w1, r1);"
    algorithm                                    +" down (r1, w0, r0);   updown (r0)}"
new_Test March_B        ( 17n )     +" { updown (w0); up (r0, w1, r1, w0, r0, w1);"
    algorithm                                      +" up (r1, w0, w1);"
    algorithm                                    +" down (r1, w0, w1, w0);"
    algorithm                                    +" down (r0, w1, w0)}"

new_Test GalColumn      ( 6n+4nR )  +" { up (w0); up b (w[b]1,northsouth(r0, r[b]1),w[b]0);"
    algorithm                         +" up (w1); up b (w[b]0,northsouth(r1, r[b]0),w[b]1)}"
new_Test GalRow         ( 6n+4nC )  +" { up (w0); up b (w[b]1,  eastwest(r0, r[b]1),w[b]0);"
    algorithm                         +" up (w1); up b (w[b]0,  eastwest(r1, r[b]0),w[b]1)}"
new_Test WalkColumn     ( 8n+2nR )  +" { up (w0); up b (w[b]1,northsouth(r0),r[b]1, w[b]0);"
    algorithm                         +" up (w1); up b (w[b]0,northsouth(r1),r[b]0, w[b]1)}"
new_Test WalkRow        ( 8n+2nC )  +" { up (w0); up b (w[b]1,  eastwest(r0),r[b]1, w[b]0);"
    algorithm                         +" up (w1); up b (w[b]0,  eastwest(r1),r[b]0, w[b]1)}"

new_Test Walking_1/0                +" { updown (w0); updown a (w[a]1,     updown -a (r0), r[a]1,  w[a]0);"
    algorithm                         +" updown (w1); updown a (w[a]0,     updown -a (r1), r[a]0,  w[a]1)}"
new_Test GALPAT                     +" { updown (w0); updown a (w[a]1,     updown -a (r0,  r[a]1), w[a]0);"
    algorithm                         +" updown (w1); updown a (w[a]0,     updown -a (r1,  r[a]0), w[a]1)}"
new_Test GALCOL                     +" { updown (w0); updown a (w[a]1,   eastwest -a (r0,  r[a]1), w[a]0);"
    algorithm                         +" updown (w1); updown a (w[a]0,   eastwest -a (r1,  r[a]0), w[a]1)}"
new_Test GALROW1                    +" { updown (w0); updown a (w[a]1, northsouth -a (r0,  r[a]1), w[a]0);"
    algorithm                         +" updown (w1); updown a (w[a]0, northsouth -a (r1,  r[a]0), w[a]1)}"

new_Test Checkerboard               +" { updown [2,2] (w[0,0]1, w[0,1]0, w[1,0]0, w[1,1]1);"
    algorithm                         +" updown [2,2] (r[0,0]1, r[0,1]0, r[1,0]0, r[1,1]1);"
    algorithm                         +" updown [2,2] (w[0,0]0, w[0,1]1, w[1,0]1, w[1,1]0);"
    algorithm                         +" updown [2,2] (r[0,0]0, r[0,1]1, r[1,0]1, r[1,1]0)}"

new_Test Butterfly                  +" { updown (w0); updown a (w1, r[a,a+1]0, r[a+1,a]0, r[a,a-1]0, r[a-1,a]0, w0);"
    algorithm                         +" updown (w1); updown a (w0, r[a,a+1]1, r[a+1,a]1, r[a,a-1]1, r[a-1,a]1, w1)}"

new_Test Cocktail_March             +" { up (w00000000); up (r00000000, w11111111, r11111111);"
    algorithm                                       +" up (r11111111, w00000000, r00000000);"
    algorithm                                       +" down (r00000000, w11111111);"
    algorithm                                       +" down (r11111111, w00000000); up (r00000000);"
    algorithm                         +" up (w01010101); up (w10101010); up (r10101010, w01010101, r01010101);"
    algorithm                         +" up (w00110011); up (w11001100); up (r11001100, w00110011, r00110011);"
    algorithm                         +" up (w00001111); up (w11110000); up (r11110000, w00001111, r00001111)}"
