\ Open Memory Test Language parser
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\
\ Concepts translated from the a lex & yacc front-end to:
\
\ Ad J. van de Goor, Aad Offerman, and Ivo Schanstra:
\ Towards a Uniform Notation for Memory Tests
\ presented at the European Design & Test Conference and Exhibition 96
\
\ In here you can find a predecessor to the language above that is much more
\ limited (more like an extension to the March test notation) and thus
\ much more cleaner.
\
\ Memory Test Verification and Generation
\  Copyright 1995, A. Offerman (offerman@einstein.et.tudelft.nl),
\                  H.I. Schanstra (ivo@duteca.et.tudelft.nl),
\                  Section Computer Architecture & Digital Systems,
\                  Department of Electrical Engeneering,
\                  Delft University of Technology, The Netherlands
\  All rights reserved
\
\ http://www.offerman.net/memory/mtl.tgz

\ The port part of a memory or fault is modelled using the decoder and sensebank
\ datastructures.  In turn, a decodr uses a connectivity matrix, while a
\ sensebank uses a sense amp list.  Both structures use the identity mask,
\ which is information steering the layout process.  A stuck-open mask
\ is also part of each port.

require ../ffl/stc.fs
require Overlap_constraint.fth
require Neighborhood.fth

: Identity_mask:   cell: ;				\ Vector containing int(s)

struct: Identity
        Identity_mask: a_identity_mask
    Mirror_constraint: a_mirror_constraint
    Neighborhood_list: a_neighborhood_list
;struct

: Connection:   char: ;					\ Represents a connection in the addressing
										\ mechanism of a memory
0 constant not_connected
1 constant connected

: Connectivity_matrix:   cell: ;		\ Matrix ??? containing Connection(s)

struct: Decoder
  Connectivity_matrix: decoder_connectivity_matrix
       Identity field: decoder_identity
;struct

: decoder.expand ( new_size mapping -- decoder )
	cr ." decoder.expand " cr
	drop Decoder swap vnew
;
