\ Open Memory Test Language parser
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\
\ Concepts translated from the a lex & yacc front-end to:
\
\ Ad J. van de Goor, Aad Offerman, and Ivo Schanstra:
\ Towards a Uniform Notation for Memory Tests
\ presented at the European Design & Test Conference and Exhibition 96
\
\ In here you can find a predecessor to the language above that is much more
\ limited (more like an extension to the March test notation) and thus
\ much more cleaner.
\
\ Memory Test Verification and Generation
\  Copyright 1995, A. Offerman (offerman@einstein.et.tudelft.nl),
\                  H.I. Schanstra (ivo@duteca.et.tudelft.nl),
\                  Section Computer Architecture & Digital Systems,
\                  Department of Electrical Engeneering,
\                  Delft University of Technology, The Netherlands
\  All rights reserved
\
\ http://www.offerman.net/memory/mtl.tgz

: <?> ( n -- )   .s drop ."  <?>" cr ;

include ffl/stc.fs
include Vectors.fth
include Structs.fth
include Classes/State_mask.fth
include Classes/Effect_mask.fth
include Classes/Array_operation.fth
include Classes/Chip_operation.fth
include Classes/Chip_output.fth
include Classes/Forced_state.fth
include Classes/New_state.fth
include Classes/Effect_mask_list.fth
include Classes/Position_constraint.fth
include Classes/Overlap_constraint.fth
include Classes/Neighborhood.fth
include Classes/Decoder.fth
include Classes/Sense_bank.fth
include Classes/Port.fth
include Classes/Memory_type.fth
include Classes/Memory_chip.fth
include Classes/Fault_set.fth
include Classes/Fault.fth
include Classes/Test_set.fth
include Classes/Test.fth
include Data.fth
include Algorithms.fth
include Memory.fth
include gray.fs
include mtl_prs.fth

: tsc ( -- )   Test_set# @ >r
    Test_set.size 0 do
        i Test_set# !  cr ." Testing "
        current_test test_name @ count type space
        algorithm @+ tscan
    loop  r> Test_set# !
;

include mtla_prs.fth

: tpa ( -- )   Test_set# @ >r
    Test_set.size 0 do
        cr i dup . Test_set# !  ." Testing "
        current_test test_name @ count type space
        algorithm @+ aparse
    loop  r> Test_set# !
;

include mtli_prs.fth

: tpi ( -- )   Test_set# @ >r
    Test_set.size 0 ( 2drop 26 24 ) do
        cr i dup . Test_set# !  ." Testing "
        current_test test_name @ count type space
        algorithm @+ iparse
        depth if .s  true abort" stack not empty" then
    loop  r> Test_set# !
;

include mtlp_prs.fth

: tpp ( -- )   Test_set# @ >r
    Test_set.size ( drop 1 ) 0 do
        cr i dup . Test_set# !  ." Testing "
        current_test test_name @ count type space
        algorithm @+ pparse
    loop  r> Test_set# !
;

Zero-One Test_set# !

include Verify.fth

: tca ( -- )   Test_set# @ >r
    Test_set.size 0 do
        cr i dup . Test_set# !  ." Testing "
        current_test test_name @ count type space
        mtl_compute_attributes .
    loop  r> Test_set# !
;

: tvc ( -- )   Test_set# @
    Test_set.size 0 do
        i Test_set# !  xmtvg_verify_for_completeness
        inMemory verify_chip .
    loop  Test_set# !
;
