\ Open Memory Test Language data structures
\
\ Copyright 2006 Dennis Ruffer (druffer@worldnet.att.net)
\
\     This program is free software; you can redistribute it and/or modify
\     it under the terms of the GNU General Public License as published by
\     the Free Software Foundation; either version 2 of the License, or
\     (at your option) any later version.
\
\     This program is distributed in the hope that it will be useful,
\     but WITHOUT ANY WARRANTY; without even the implied warranty of
\     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\     GNU General Public License for more details.
\
\     You should have received a copy of the GNU General Public License
\     along with this program; if not, write to the Free Software
\     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
\
\ Concepts adapted from:
\
\ Automatic Memory Test Verification and Generation
\ Masters Thesis writen by A. Offerman
\ Section Computer Architecture & Digital Systems
\ Department of Electrical Engineering
\ Delft University of Technology
\ The Netherlands
\ August 1995

hex

0CA constant "updown"
0C8 constant "down"
0C9 constant "up"
0CD constant "northsouth"
0CB constant "south"
0CC constant "north"
0D0 constant "eastwest"
0CE constant "east"
0CF constant "west"

decimal

\ Data Structures extracted from Appendix B, written by Ivo Schanstra

\ All vector-like structures have been implemented dynamically, using pointer
\ structures, which means that they have no fixed size or boundaries

: char_*:      cell: ;					\ Vector containing character strings
: int:         cell: ;					\ Holds integer numbers
: Flag:        cell: ;					\ Holds binary flags
\ : floating:   float: ;				\ Holds a real (floating-point) value

\ : Real_list:   cell: ;				\ Vector containing floating value(s)
